//
//  main.cpp
//  HW#8
//
//  Created by Tammy on 4/25/15.
//  Copyright (c) 2015 Tammy. All rights reserved.
//

#include <iostream>
using namespace std;

// define Randomizor class
class Randomizor{
public:
    int rand();
    bool srand(int s);
    Randomizor(int in1, int in2, int in3);
private:
    int a, b, c, cur;
};
// constructor
Randomizor::Randomizor(int in1, int in2, int in3){
    a = in1;
    b = in2;
    c = in3;
    cur = 0;
}
// a function that will generate random numbers
int Randomizor::rand(){
    cur = (a*cur+b)%c;
    return cur;
}
// a function that will pass the seed to the rand function
bool Randomizor::srand(int s){
    if(s>0){
        cur = s;
        return true;
    }
    else
        return false;
}

int main() {
    int a=0, b=0, c=0, cur=0, n=0;
    cin >> a >> b >> c >> cur >> n;
    // declare r with Randomizor class attributes
    Randomizor r(a,b,c);
    
    // invoke srand function to generate the seed
    r.srand(cur);
    // invoke the rand function to generate the random numbers and print the first one
    cout << r.rand();
    for(int i=1; i<n; i++){
        // print the other numbers
        cout << " " << r.rand();
    }

    return 0;
}
